/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpRpCNX                   */
/*      \            BaseCompiler                                          */
/*      pbP[W  jsd.compiler                                          */
/*      ŏIXV      2007/06/14(Wed)                                       */
/*      o[W      1.00.03                                               */
/*      쌠\      Copyright (C) 2005-2007 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * RpCNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.compiler.BaseCompilerNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.compiler.BaseCompiler";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V log js.cpt.Log K[
  var log = new js.cpt.Log(Creator.CompleteName);
  
  //------------------------------------------------------------------------------
  function findLineSeparator(src)
   /**
    * sR[h
    * @param src String 팟
    * @return String sR[hiKLF,CR,CRLF,LFCR̂ꂩԂj
    */
    {
    if(!src)
      {
      return "\n";
      }
    else if(src.indexOf("\r", 0) < 0)
      {
      return "\n";
      }
    else if(src.indexOf("\n", 0) < 0)
      {
      return "\r";
      }
    else if(src.indexOf("\r\n", 0) >= 0)
      {
      return "\r\n";
      }
    else if(src.indexOf("\n\r", 0) >= 0)
      {
      return "\n\r";
      }
    else
      {
      return "\n";
      }
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S MEAN_URI_VALUE String Ӗ:URIl
  Static.MEAN_URI_VALUE = "uri-value";
  //:S MEAN_CLASS_NAME String Ӗ:NX
  Static.MEAN_CLASS_NAME = "class-name";
  //:S MEAN_PACKAGE_NAME String Ӗ:pbP[W
  Static.MEAN_PACKAGE_NAME = "package-name";
  //:S MEAN_VARIABLE_NAME String Ӗ:ϐ
  Static.MEAN_VARIABLE_NAME = "variable-name";
  //:S MEAN_DATE_TIME String Ӗ:
  Static.MEAN_DATE_TIME = "date-time";
  //:S MEAN_CDATA String Ӗ:CDATAZNV
  Static.MEAN_CDATA = "#cdata-section";
  //:S MEAN_TEXT String Ӗ:eLXg
  Static.MEAN_TEXT = "#text";
  //:S MEAN_COMMENT String Ӗ:Rg
  Static.MEAN_COMMENT = "#comment";
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.compile = function(source, mean)
   /**
    * RpCs
    * @param source Date|Boolean|Number|String|null|undefined \[X
    * @param mean [String|null] \[ẌӖisourceString^łꍇ̂ݗLj(Static.MEANI)
    * @return jsd.xml.XmlNode|null RpC
    */
    {
    log.trace("P:compile - begin - ", source, mean);
    var node = null;
    switch(typeof source)
      {
      case "boolean":
        node = Super.prototype.compile.call(this, source, "boolean");
        break;
      case "number":
        node = Super.prototype.compile.call(this, source, "number");
        break;
      case "string":
        switch(mean)
          {
          // QKw
          case Static.MEAN_URI_VALUE:
          case Static.MEAN_CLASS_NAME:
          case Static.MEAN_PACKAGE_NAME:
          case Static.MEAN_VARIABLE_NAME:
          case Static.MEAN_DATE_TIME:
            node = Super.prototype.compile.call(this, null, mean);
            node.appendChild(Super.prototype.compile.call(this, source, Static.MEAN_TEXT));
            break;
          // PKw
          default:
            mean = Static.MEAN_TEXT;
          case Static.MEAN_TEXT:
          case Static.MEAN_CDATA:
          case Static.MEAN_COMMENT:
            node = Super.prototype.compile.call(this, source, mean);
            node.toString = function(nestSpace, firstSpace, minimizable)
              {
              var str = this.constructor.prototype.toString.apply(this, arguments);
              if(str && (/\n|\r/).test(str) && firstSpace && (/\n|\r/).test(firstSpace))
                {
                var newLS = findLineSeparator(firstSpace);
                var nowLS = findLineSeparator(str);
                if(newLS != nowLS)
                  {
                  switch(nowLS)
                    {
                    case "\n":
                      str = str.replace(/\n/g, newLS);
                      break;
                    case "\r":
                      str = str.replace(/\r/g, newLS);
                      break;
                    case "\r\n":
                      str = str.replace(/\r\n/g, newLS);
                      break;
                    case "\n\r":
                      str = str.replace(/\n\r/g, newLS);
                      break;
                    default:
                    }
                  }
                }
              return str;
              };
          }
        break;
      case "object":
        if(source instanceof Date)
          {
          source = (function(source)
            {
            var year  = source.getFullYear();
            var month = source.getMonth() + 1;
            var date  = source.getDate();
            return (day  = year + "/" + ((month < 10) ? "0" : "") + month + "/" + ((date < 10) ? "0" : "") + date);
            })(source);
          node = Super.prototype.compile.call(this, null, Static.MEAN_DATE_TIME);
          node.appendChild(Super.prototype.compile.call(this, source, Static.MEAN_TEXT));
          }
        else
          {
          node = null;
          }
        break;
      case "function":
      case "null":
      case "undefined":
      default:
        node = null;
      }
    log.trace("P:compile - end - ", node);
    return node;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * RpCNX
    * @return jsd.compiler.BaseCompiler CX^X
    */
    {
    log.trace("F:Class - begin -");
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    log.trace("F:Class - end -");
    return this;
    }
  
  return Class;
  }, jsd.compiler.AbstractCompiler);

