/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCppbP[W`t@CRpCNX */
/*      \            PackageCompiler                                       */
/*      pbP[W  jsd.compiler                                          */
/*      ŏIXV      2007/04/28(Sun)                                       */
/*      o[W      1.01.00                                               */
/*      쌠\      Copyright (C) 2006-2007 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * pbP[W`t@CRpCNX
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.compiler.PackageCompilerNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "jsd.compiler.PackageCompiler";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V _PACKAGE_ Function js.cpt.Package
  var _PACKAGE_ = js.cpt.Package;
  //:V _CLASS_ Function js.cpt.Class
  var _CLASS_ = js.cpt.Class;
  //:V XmlNode Function jsd.xml.XmlNode
  var XmlNode = jsd.xml.XmlNode;
  //:V File Function jsd.ref.File
  var File = jsd.ref.File;
  //:V CompileCondition Function jsd.compiler.CompileCondition
  var CompileCondition = jsd.compiler.CompileCondition;
  //:V DefinitionCompiler Function jsd.compiler.DefinitionCompiler
  var DefinitionCompiler = jsd.compiler.DefinitionCompiler;
  //:V CreatorCompiler Function jsd.compiler.CreatorCompiler
  var CreatorCompiler = jsd.compiler.CreatorCompiler;
  
  //:V MemberCompiler Function jsd.compiler.MemberCompiler
  var MemberCompiler = jsd.compiler.MemberCompiler;
  
  //:V JsdFactory Function js.debug.jsd.JsdFactory
  var JsdFactory = js.debug.jsd.JsdFactory;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V log js.cpt.Log K[
  var log = new js.cpt.Log(Creator.CompleteName);
  
  //:V ROOT_NODE_NAME String [gm[h
  var ROOT_NODE_NAME = "define";
  //:V HEAD_NODE_NAME String wb_m[h
  var HEAD_NODE_NAME = "head";
  //:V BODY_NODE_NAME String {fBm[h
  var BODY_NODE_NAME = "body";
  //:V LINK_NODE_NAME String Nm[h
  var LINK_NODE_NAME = "link";
  //:V CLASSES_NODE_NAME String NX`Xgm[h
  var CLASSES_NODE_NAME = "define-classes";
  //:V CLASS_NODE_NAME String NX`m[h
  var CLASS_NODE_NAME = "define-class";
  
  //:V CREATOR_NODE_NAME String NG[^[m[h
  var CREATOR_NODE_NAME = "creator";
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S XMLNS_URI String XMLOURI
  Static.XMLNS_URI = "";
  
  //------------------------------------------------------------------------------
  Static.functionToString = function(func)
   /**
    * ֐𕶎񉻂
    * @param func Function ֐
    * @return String|null 񉻂ꂽ֐
    */
    {
    log.trace("S:functionToString - begin - ", func);
    var str = null;
    if((typeof func) == "function")
      {
      var nativeToString = (function(){}).toString;
      var originalToString;
      if(func.toString != nativeToString)
        {
        originalToString = func.toString;
        delete func.toString;
        }
      str = func.toString(0);
      if(originalToString)
        {
        func.toString = originalToString;
        }
      }
    log.trace("S:functionToString - end - ", str);
    return str;
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P definitionCompiler jsd.compiler.DefinitionCompiler|null NX`RpC̃CX^X
  Proto.definitionCompiler = null;
  //:P creatorCompiler jsd.compiler.CreatorCompiler|null NG[^[RpC̃CX^X
  Proto.creatorCompiler = null;
  //:P memberCompiler jsd.compiler.MemberCompiler|null oRpC̃CX^X
  Proto.memberCompiler = null;
  
  //------------------------------------------------------------------------------
  Proto.compile = function(source, cond)
   /**
    * RpCs
    * @param source String \[X(SCpbP[W)
    * @param cond jsd.compiler.CompileCondition RpC
    * @return jsd.xml.XmlNode|null RpC
    */
    {
    log.trace("P:compile - begin - ", source, cond);
    var node = null;
    if(!source || ((typeof source) != "string"))
      {
      return node;
      }
    if(!cond || ((typeof cond) != "object") || !(cond instanceof CompileCondition))
      {
      return node;
      }
    log.trace("pbP[W`RpCJn");
    var define, defFile, defName, defOpts;
    try
      {
      define  = _PACKAGE_.getDefinition(source);
      defFile = cond.getDefinitionFile(source);
      defName = (defFile.indexOf(File.EXTENSION_TOKEN, 0) >= 0) ? defFile.substring(0, defFile.indexOf(File.EXTENSION_TOKEN, 0)) : defFile;
      defOpts = cond.getDefinitionOptions(source);
      log.trace("IuWFNg", " `֐=", !!define, " `t@C=", !!defFile, " `=", !!defName, " IvV=", defOpts);
      if(define && defFile && defName)
        {
        // 	OD[g쐬
        node = Super.prototype.compile.call(this, null, ROOT_NODE_NAME);
        node.setAttribute("id", defFile);
        var xmlns = Static.XML_NAMESPACE;
        if(xmlns)
          {
          node.setAttribute(("xmlns:" + xmlns), Static.XMLNS_URI);
          }
        log.trace("[gm[h쐬", node);
        // PDwb_쐬
        var head = Super.prototype.compile.call(this, null, HEAD_NODE_NAME);
        node.appendChild(head);
        log.trace("wb_m[h쐬", head);
        (function()
          {
          var link;
          // P|PDpbP[W`t@C (̃t@Ĉ߁Aȗ)
          // P|QDfvCx[X
          var nameList = cond.getBaseDirectories();
          if(nameList)
            {
            for(var i = 0; i < nameList.length; i++)
              {
              var name = nameList[i];
              var dir  = cond.getBaseDirectory(name);
              var ext  = cond.getBaseExtension(name);
              link = Super.prototype.compile.call(this, null, LINK_NODE_NAME);
                {
                link.setAttribute("rel", "Base");
                link.setAttribute("class", name);
                link.setAttribute("href", dir);
                if((typeof ext) == "string")
                  {
                  link.setAttribute("extension", ext);
                  }
                }
              head.appendChild(link);
              log.trace("fvCx[Xm[h(", (i + 1), "/" + nameList.length, ")쐬", link);
              }
            }
          // P|RD
          var uri = cond.getIndexUri();
          if(uri)
            {
            link = Super.prototype.compile.call(this, null, LINK_NODE_NAME);
              {
              link.setAttribute("rel", "Index");
              link.setAttribute("href", uri);
              }
            head.appendChild(link);
            log.trace("m[h쐬", link);
            }
          // P|SDڎ
          var uri = cond.getContentsUri();
          if(uri)
            {
            link = Super.prototype.compile.call(this, null, LINK_NODE_NAME);
              {
              link.setAttribute("rel", "Contents");
              link.setAttribute("href", uri);
              }
            head.appendChild(link);
            log.trace("ڎm[h쐬", link);
            }
          })();
        // QD{fB쐬
        var body = Super.prototype.compile.call(this, null, BODY_NODE_NAME);
        node.appendChild(body);
        log.trace("{fBm[h쐬", body);
        (function()
          {
          // X[p[NXm[h
          var SUPERCLASS_NODE_NAME = "super-class";
          // m̃TuNXm[h
          var SUBCLASS_NODE_NAME = "sub-class";
          // ̃R}hm[h
          var NAME_COMMAND_NODE_NAME = "command-name";
          // _~[NX`
          var cls = new _CLASS_(defName, null, defOpts);
          // Q|PDpbP[W` - ꕔ̏͌ォ
          var def_cp = (this.definitionCompiler instanceof DefinitionCompiler) ? this.definitionCompiler : (this.definitionCompiler = new DefinitionCompiler());
          var defNode = def_cp.compile(cls, defFile, source);
          for(var next, child = defNode.firstChild; child; child = next)
            {
            next = child.nextSibling;
            var nodeName = child.nodeName;
            if((nodeName == SUPERCLASS_NODE_NAME) || (nodeName == SUBCLASS_NODE_NAME))
              {
              defNode.removeChild(child);
              }
            }
          body.appendChild(defNode);
          log.trace("pbP[W`m[h쐬", defNode);
          // Q|QDNG[^[
          var cre_cp = (this.creatorCompiler instanceof CreatorCompiler) ? this.creatorCompiler : (this.creatorCompiler = new CreatorCompiler());
          var creatorNode = cre_cp.compile((new JsdFactory(Static.functionToString(define))).create());
          if(creatorNode)
            {
            for(var next, child = creatorNode.firstChild; child; child = next)
              {
              next = child.nextSibling;
              var nodeName = child.nodeName;
              if(nodeName == NAME_COMMAND_NODE_NAME)
                {
                var name = (child.firstChild && child.firstChild.firstChild) ? child.firstChild.firstChild.nodeValue : null;
                if(name)
                  {
                  defNode.setAttribute("name", name);
                  }
                break;
                }
              }
            body.appendChild(creatorNode);
            log.trace("NG[^[m[h쐬", creatorNode);
            }
          // Q|RD`NXiXgj
          var defineClasses = Super.prototype.compile.call(this, null, CLASSES_NODE_NAME);
          body.appendChild(defineClasses);
          log.trace("NX`Xgm[h쐬", defineClasses);
          // Q|SD`NXiʁj
          var classNames = _PACKAGE_.getClassNamesByDefinition(define);
          if(classNames)
            {
            var defineCreator;
            for(var i = 0; i < classNames.length; i++)
              {
              creatorNode = cond.findClassDoc(classNames[i]);
              if(creatorNode)
                {
                creatorNode = creatorNode.getElementsByTagName(CREATOR_NODE_NAME);
                creatorNode = (creatorNode && (creatorNode.length > 0)) ? creatorNode[0] : null;
                if(creatorNode)
                  {
                  creatorNode = creatorNode.cloneNode();
                  }
                }
              if(!creatorNode)
                {
                defineCreator = _CLASS_.getCreator(classNames[i]);
                if(defineCreator)
                  {
                  creatorNode = cre_cp.compile((new JsdFactory(Static.functionToString(defineCreator))).create());
                  }
                }
              if(creatorNode)
                {
                creatorNode.nodeName = CLASS_NODE_NAME;
                creatorNode.setAttribute("base", classNames[i]);
                defineClasses.appendChild(creatorNode);
                log.trace("NX`Xgʃm[h쐬", creatorNode);
                }
              else
                {
                log.warn("NX`Xgʃm[h쐬s (", classNames[i], ")");
                }
              }
            }
          })();
        }
      }
    catch(e)
      {
      log.error(e.message, e);
      log.error("StackTrace = " + e.stackTrace);
      node = null;
      }
    log.trace("P:compile - end - ", node);
    return node;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * pbP[W`t@CRpCNX
    * @return jsd.compiler.PackageCompiler CX^X
    */
    {
    log.trace("F:Class - begin -");
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    log.trace("F:Class - end -");
    return this;
    }
  
  return Class;
  }, jsd.compiler.AbstractCompiler);

