/******************************************************************************/
/*                                                                            */
/*      Tv            WJc[\NX                                  */
/*      \            ExtensibleTree                                        */
/*      pbP[W  jsd.container                                         */
/*      ŏIXV      2006/05/06(Sat)                                       */
/*      o[W      2.01.00                                               */
/*      쌠\      Copyright (C) 2005-2006 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

// ̃NX̓Rs[ꂽ̂ŁA͂̃pbP[Wł͂ȂB

Class.create(function(Super)
 /**
  * WJc[\NXNG[^[
  * @update 2005/05/06
  * @version 2.01
  * @author Mug
  * @param Super [Function|null] X[p[NX
  * @return Function ExtensibleTreeNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "jsd.container.ExtensibleTree";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = (Class.Static = {});
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  function addMarker(frameObj, extendItem)
   /**
    * }[J[ǉ
    * @param frameObj Object t[IuWFNg
    * @param extendItem [Object] WJACeIuWFNg
    * @return Boolean WJACe݂ǂ
    */
    {
    var hasExtendItem = false;
    var children = frameObj.childNodes;
    var itemObj = null;
    for(var c = 0; (children && (c < children.length)); c++)
      {
      var child = children[c];
      if(child.nodeName.charAt(0) != "#")
        {
        if(Class.checkItemNode(child))
          {
          if(itemObj)
            {
            insertMarker(itemObj, Class.PointMarker);
            hasExtendItem = hasExtendItem || (itemObj == extendItem);
            }
          itemObj = child;
          }
        else if(Class.checkDetailNode(child))
          {
          if(itemObj)
            {
            var hasEI = false;
            // ċA
            var grandChildren = child.childNodes;
            for(var g = 0; (grandChildren && (g < grandChildren.length)); g++)
              {
              var grandChild = grandChildren[g];
              if(grandChild.nodeName.charAt(0) != "#")
                {
                if(Class.checkFrameNode(grandChild))
                  {
                  hasEI = arguments.callee(grandChild, extendItem);
                  }
                }
              }
            // Item
            hasEI = hasEI || (itemObj == extendItem);
            var isInserted = insertMarker(itemObj, (hasEI ? Class.MinusMarker : Class.PlusMarker), child);
            if(isInserted)
              {
              child.style.display = hasEI ? "" : "none";
              }
            itemObj = null;
            hasExtendItem = hasExtendItem || hasEI;
            }
          }
        }
      }
    if(itemObj)
      {
      insertMarker(itemObj, Class.PointMarker);
      hasExtendItem = hasExtendItem || (itemObj == extendItem);
      }
    return hasExtendItem;
    }
  //------------------------------------------------------------------------------
  function insertMarker(itemObj, marker, childObj)
   /**
    * }[J[m[hɑ}
    * @param itemObj Object }Ώۃm[h
    * @param marker String }[J[
    * @param childObj [Object] \Ώۂ̎qvf
    * @return Boolean }[J[IuWFNg}ǂ
    */
    {
    var isInserted = false;
    // }[J[T
    var markerObj = null;
    var children = itemObj.childNodes;
    for(var c = 0; (children && (c < children.length)); c++)
      {
      var child = children[c];
      if(child.nodeName.charAt(0) != "#")
        {
        markerObj = child;
        break;
        }
      }
    // }[J[쐬Ȃ쐬
    var markerText = markerObj ? markerObj.innerHTML : null;
    if(!markerObj || ((markerText != Class.PlusMarker) && (markerText != Class.MinusMarker) && (markerText != Class.PointMarker)))
      {
      // vf̂Ps\
      if(Class.ItemNoWrap)
        {
        itemObj.style.whiteSpace = "nowrap";
        }
      // |bvAbv^Cg̎쐬
      if(Class.ItemTitle)
        {
        var title = itemObj.innerHTML;
        title = title.replace(new RegExp("\\t", "g"), "&#09;");
        title = title.replace(new RegExp("<br(?:\\W.*)?>", "gi"), "&#10;");
        title = title.replace(new RegExp("<.*?>", "g"), "");
        title = title.replace(new RegExp("\\r", "g"), "");
        title = title.replace(new RegExp("\\n", "g"), "");
        if(itemObj.title)
          {
          title = "&#10;" + itemObj.title;
          }
        itemObj.title = title;
        }
      // }[J[쐬
      markerObj = Class.BaseWindow.document.createElement("span");
      markerObj.innerHTML = marker;
      if((marker == Class.PointMarker) && Class.PointClass)
        {
        markerObj.className = Class.PointClass;
        }
      else if(Class.MarkerClass)
        {
        markerObj.className = Class.MarkerClass;
        }
      if((marker == Class.PointMarker) && Class.PointStyle)
        {
        markerObj.style.cssText = Class.PointStyle;
        }
      else if(Class.MarkerStyle)
        {
        markerObj.style.cssText = Class.MarkerStyle;
        }
      if(children && (children.length > 0))
        {
        itemObj.insertBefore(markerObj, children[0]);
        }
      else
        {
        itemObj.appendChild(markerObj);
        }
      isInserted = true;
      // }[J[Cxg
      if(childObj && (marker != Class.PointMarker))
        {
        markerObj.onclick = function()
          {
          if(this.innerHTML == Class.MinusMarker)
            {
            if((typeof(itemObj.onclose) != "function") || (itemObj.onclose(childObj) !== false))
              {
              childObj.style.display = "none";
              this.innerHTML = Class.PlusMarker;
              if(typeof(childObj.onclose) == "function")
                {
                childObj.onclose(itemObj);
                }
              }
            }
          else if(this.innerHTML = Class.PlusMarker)
            {
            if((typeof(itemObj.onopen) != "function") || (itemObj.onopen(childObj) !== false))
              {
              childObj.style.display = "";
              this.innerHTML = Class.MinusMarker;
              if(typeof(childObj.onopen) == "function")
                {
                childObj.onopen(itemObj);
                }
              }
            }
          };
        }
      }
    return isInserted;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //:C BaseWindow Object EBhE
  Class.BaseWindow = (function() { return this; })();
  
  // }[J[ݒ
  //:C PlusMarker String WJ}[J[
  Class.PlusMarker  = "{";
  //:C MinusMarker String [}[J[
  Class.MinusMarker = "|";
  //:C PointMarker String I[vf}[J[
  Class.PointMarker = "";
  //:C MarkerClass String|null }[J[NX
  Class.MarkerClass = null;
  //:C MarkerStyle String|null }[J[X^C
  Class.MarkerStyle = null;
  //:C PointClass String|null I[vf}[J[NX
  Class.PointClass  = null;
  //:C PointStyle String|null I[vf}[J[X^C
  Class.PointStyle  = null;
  
  // Fp^[
  //:C FrameTag String|null t[^O
  Class.FrameTag    = null;
  //:C FrameClass String|null t[^ONX
  Class.FrameClass  = null;
  //:C ItemTag String|null vf^O
  Class.ItemTag     = null;
  //:C ItemClass String|null vf^ONX
  Class.ItemClass   = null;
  //:C DetailTag String|null ڍ׃^O
  Class.DetailTag   = null;
  //:C DetailClass String|null ڍ׃^ONX
  Class.DetailClass = null;
  
  // \IvV
  //:C ItemNoWrap Boolean evfPsŕ\邩ǂ
  Class.ItemNoWrap = false;
  //:C ItemTitle Boolean |bvAbv^Cg쐬邩ǂ
  Class.ItemTitle = false;
  
  //------------------------------------------------------------------------------
  Class.checkFrameNode = function(cNode)
   /**
    * t[m[h`FbN
    * @param cNode Object Ώۃm[h
    * @return Boolean t[m[hǂ
    */
    {
    var tagName = cNode.nodeName;
    if(tagName)
      {
      tagName = tagName.toLowerCase();
      }
    var clsName = cNode.className;
    if(clsName)
      {
      clsName = clsName.toLowerCase();
      }
    return ((!Class.FrameTag || (Class.FrameTag.toLowerCase() == tagName)) && (!Class.FrameClass || (Class.FrameClass.toLowerCase() == clsName)));
    };
  //------------------------------------------------------------------------------
  Class.checkItemNode = function(cNode)
   /**
    * ACem[h`FbN
    * @param cNode Object Ώۃm[h
    * @return Boolean ACem[hǂ
    */
    {
    var tagName = cNode.nodeName;
    if(tagName)
      {
      tagName = tagName.toLowerCase();
      }
    var clsName = cNode.className;
    if(clsName)
      {
      clsName = clsName.toLowerCase();
      }
    return ((!Class.ItemTag || (Class.ItemTag.toLowerCase() == tagName)) && (!Class.ItemClass || (Class.ItemClass.toLowerCase() == clsName)));
    };
  //------------------------------------------------------------------------------
  Class.checkDetailNode = function(cNode)
   /**
    * ڍ׃m[h`FbN
    * @param cNode Object Ώۃm[h
    * @return Boolean ڍ׃m[hǂ
    */
    {
    var tagName = cNode.nodeName;
    if(tagName)
      {
      tagName = tagName.toLowerCase();
      }
    var clsName = cNode.className;
    if(clsName)
      {
      clsName = clsName.toLowerCase();
      }
    return ((!Class.DetailTag || (Class.DetailTag.toLowerCase() == tagName)) && (!Class.DetailClass || (Class.DetailClass.toLowerCase() == clsName)));
    };
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(obj)
   /**
    * ExtensibleTreeNX
    * @param obj Object ΏۂƂt[IuWFNg
    * @return ExtensibleTree CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.addMarker = function(extendItem)
     /**
      * ΏۃIuWFNgȉɃ}[J[ǉ
      * @param extendItem [Object] WJACem[h
      */
      {
      addMarker(obj, extendItem);
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  });

