/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpNX`RpCNX             */
/*      \            DefinitionCompiler                                    */
/*      pbP[W  jsd.compiler                                          */
/*      ŏIXV      2006/04/29(Sat)                                       */
/*      o[W      1.00.01                                               */
/*      쌠\      Copyright (C) 2006 Mug, All rights reserved.          */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * NX`RpCNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.compiler.DefinitionCompilerNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.compiler.DefinitionCompiler";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V _CLASS_ Function js.cpt.Class
  var _CLASS_ = js.cpt.Class;
  //:V XmlNode Function jsd.xml.XmlNode
  var XmlNode = jsd.xml.XmlNode;
  //:V BaseCompiler Function jsd.compiler.BaseCompiler
  var BaseCompiler = jsd.compiler.BaseCompiler;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V log js.cpt.Log K[
  var log = new js.cpt.Log(Creator.CompleteName);
  
  //:V BASIC_NODE_NAME String {m[h
  var BASIC_NODE_NAME = "basic";
  //:V DEFINITION_NODE_NAME String `t@Cm[h
  var DEFINITION_NODE_NAME = "definition";
  //:V PACKAGE_NODE_NAME String pbP[Wm[h
  var PACKAGE_NODE_NAME = "package";
  //:V SUPERCLASS_NODE_NAME String X[p[NXm[h
  var SUPERCLASS_NODE_NAME = "super-class";
  //:V SUBCLASS_NODE_NAME String m̃TuNXm[h
  var SUBCLASS_NODE_NAME = "sub-class";
  //:V RELIANCE_NODE_NAME String ˑm[h
  var RELIANCE_NODE_NAME = "reliance";
  //:V OPTION_NODE_NAME String IvVm[h
  var OPTION_NODE_NAME = "option";
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  Class.setSubClasses = function(xmlMap, baseCp)
   /**
    * m̃TuNXݒ肷
    * @param xmlMap Object SCNXL[ɂjsd.xml.XmlNodẽ}bv
    * @param baseCp [jsd.compile.BaseCompiler|null] RpCCX^X
    */
    {
    log.trace("C:setSubClasses - begin - ", xmlMap, baseCp);
    if(!baseCp || !(baseCp instanceof BaseCompiler))
      {
      baseCp = new BaseCompiler();
      }
    if((typeof xmlMap) == "object")
      {
      // sXMLr
      for(var className in xmlMap)
        {
        var classNode = xmlMap[className];
        if(!classNode || !(classNode instanceof XmlNode) || (classNode.getAttribute("id") != className))
          {
          xmlMap[className] = null;
          }
        }
      // m̃TuNXݒ
      for(var className in xmlMap)
        {
        var classNode = xmlMap[className];
        var bodyNode = classNode.lastChild;
        var baseNode = bodyNode ? bodyNode.firstChild : null;
        if(baseNode && baseNode.childNodes)
          {
          for(var i = 0; i < baseNode.childNodes.length; i++)
            {
            var child = baseNode.childNodes[i];
            // <super-class>
            if(child && (child.nodeName == "super-class") && child.childNodes)
              {
              for(var j = 0; j < child.childNodes.length; j++)
                {
                var gc = child.childNodes[j];
                // <class-name>
                if(gc && (gc.nodeName == "class-name"))
                  {
                  var supName = gc.firstChild ? gc.firstChild.nodeValue : null;
                  // o^
                  var supClass = supName ? xmlMap[supName] : null;
                  var supBody  = supClass ? supClass.lastChild : null;
                  var supBase  = supBody ? supBody.firstChild : null;
                  if(supBase && supBase.childNodes)
                    {
                    for(var k = 0; k < supBase.childNodes.length; k++)
                      {
                      var supChild = supBase.childNodes[k];
                      // <sub-class>
                      if(supChild && (supChild.nodeName == "sub-class"))
                        {
                        // `FbN
                        var hasThis = false;
                        if(supChild.childNodes)
                          {
                          for(var m = 0; m < supChild.childNodes.length; m++)
                            {
                            var bc = supChild.childNodes[m];
                            if(bc && (bc.nodeName == "class-name"))
                              {
                              if(bc.firstChild && (bc.firstChild.nodeValue == className))
                                {
                                hasThis = true;
                                break;
                                }
                              }
                            }
                          }
                        // m[hǉ
                        if(!hasThis)
                          {
                          supChild.appendChild(baseCp.compile(className, BaseCompiler.Static.MEAN_CLASS_NAME));
                          }
                        break;
                        }
                      }
                    }
                  break;
                  }
                }
              break;
              }
            }
          }
        }
      }
    log.trace("C:setSubClasses - end");
    };
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P baseCompiler jsd.compiler.BaseCompiler|null RpCCX^X
  Proto.baseCompiler = null;
  
  //------------------------------------------------------------------------------
  Proto.compile = function(source, defFile, pakName, supNames)
   /**
    * RpCs
    * @param source js.cpt.Class \[X
    * @param defFile [String|null] `t@C
    * @param pakName [String|null] pbP[W
    * @param supNames [Array|null] X[p[NX̔z
    * @return jsd.xml.XmlNode|null RpC
    */
    {
    log.trace("P:compile - begin - ", source, defFile, pakName, supNames);
    var node = null;
    if(!source || ((typeof source) != "object") || !(source instanceof _CLASS_))
      {
      return node;
      }
    var base_cp = (this.baseCompiler instanceof BaseCompiler) ? this.baseCompiler : new BaseCompiler();
    node = Super.prototype.compile.call(this, null, BASIC_NODE_NAME);
    node.setAttribute("name", source.getName());
    // `t@C
    var def = Super.prototype.compile.call(this, null, DEFINITION_NODE_NAME);
    def.appendChild(base_cp.compile(defFile, BaseCompiler.Static.MEAN_URI_VALUE));
    node.appendChild(def);
    // pbP[W
    var pak = Super.prototype.compile.call(this, null, PACKAGE_NODE_NAME);
    pak.appendChild(base_cp.compile(pakName, BaseCompiler.Static.MEAN_PACKAGE_NAME));
    node.appendChild(pak);
    // X[p[NX
    var sup = Super.prototype.compile.call(this, null, SUPERCLASS_NODE_NAME);
    if(supNames)
      {
      for(var i = 0; i < supNames.length; i++)
        {
        var supName = supNames[i];
        if(supName && ((typeof supName) == "string"))
          {
          sup.appendChild(base_cp.compile(supName, BaseCompiler.Static.MEAN_CLASS_NAME));
          }
        }
      }
    node.appendChild(sup);
    // m̃TuNX
    node.appendChild(Super.prototype.compile.call(this, null, SUBCLASS_NODE_NAME));
    // ˑ
    var obj = Super.prototype.compile.call(this, null, RELIANCE_NODE_NAME);
    var rel = source.getReliances();
    if(rel)
      {
      for(var i = 0; i < rel.length; i++)
        {
        obj.appendChild(base_cp.compile(rel[i], BaseCompiler.Static.MEAN_CLASS_NAME));
        }
      }
    node.appendChild(obj);
    // IvV
    var obj = Super.prototype.compile.call(this, null, OPTION_NODE_NAME);
    obj.appendChild(base_cp.compile(source.getOptions(), BaseCompiler.Static.MEAN_CDATA));
    node.appendChild(obj);
    log.trace("P:compile - end - ", node);
    return node;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * NX`RpCNX
    * @return jsd.compiler.DefinitionCompiler CX^X
    */
    {
    log.trace("F:Class - begin");
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    log.trace("F:Class - end");
    return this;
    }
  
  return Class;
  }, jsd.compiler.AbstractCompiler);

