/******************************************************************************/
/*                                                                            */
/*      Tv            HTML\Rg[NX                            */
/*      \            DisplayControl                                        */
/*      pbP[W  jsd.container                                         */
/*      ŏIXV      2006/05/07(Sun)                                       */
/*      o[W      1.00.00                                               */
/*      쌠\      Copyright (C) 2006 Mug, All rights reserved.          */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * \Rg[NXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.container.DisplayControlNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.container.DisplayControl";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V instanceMap Object CX^X}bv
  var instanceMap = {};
  //:V GLOBAL Object O[oIuWFNg
  var GLOBAL = (function() { return this; })();
  
  //------------------------------------------------------------------------------
  function registInstance(key, instance)
   /**
    * CX^Xo^
    * @param key String L[
    * @param instance jsd.container.DisplayControl
    * @throw DoubleDefinitionException L[̏d
    * @throws StringFormatException|ParameterFormatException s
    */
    {
    if(!key || ((typeof key) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, key, "key", "NotEmptyString", "FAIL");
      }
    if(!(instance instanceof Class))
      {
      throw new Error("ParameterFormatException", Creator.CompleteName, null, instance, "instance", "jsd.container.DisplayControl", "FAIL");
      }
    if(instanceMap[key])
      {
      throw new Error("DoubleDefinitionException", Creator.CompleteName, null, key, "key", "OriginalString", "FAIL");
      }
    instanceMap[key] = instance;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  Class.setVisibility = function(obj, isVisible)
   /**
    * Ԃݒ肷
    * @param obj Object ݒΏۗvf
    * @param isVisible Boolean 邩ǂ
    */
    {
    if(((typeof obj) == "object") && ((typeof obj.style) == "object") && ((typeof obj.style) == "object"))
      {
      obj.style.visibility = isVisible ? "visible" : "hidden";
      }
    };
  //------------------------------------------------------------------------------
  Class.setDisplay = function(obj, isDisplay)
   /**
    * \Ԃݒ肷
    * @param obj Object ݒΏۗvf
    * @param isDisplay Boolean \邩ǂ
    */
    {
    if(((typeof obj) == "object") && ((typeof obj.style) == "object") && ((typeof obj.style) == "object"))
      {
      obj.style.display = isDisplay ? "" : "none";
      }
    };
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Static.getWindow = function(win)
   /**
    * EBhE(t[)擾
    * @param win String EBhE(t[)̃[g(top)ȉ̃t[
    * @return Object|null EBhEIuWFNg
    */
    {
    if((typeof win) != "string")
      {
      win = "" + win;
      }
    var target = null;
    try
      {
      target = GLOBAL.top.frames ? GLOBAL.top.frames[win] : null;
      if(!target)
        {
        target = GLOBAL.top[win];
        }
      }
    catch(e)
      {
      target = null;
      }
    return target;
    };
  //------------------------------------------------------------------------------
  Static.getElement = function(win, id)
   /**
    * HTMLvf擾
    * @param win String EBhẼ[g(top)ȉ̃t[
    * @param id String id
    * @return Object|null HTMLvf
    */
    {
    var frame = Static.getWindow(win);
    var target = (frame && frame.document) ? frame.document.getElementById(id) : null;
    return target;
    };
  //------------------------------------------------------------------------------
  Static.createElement = function(win, name)
   /**
    * HTMLvf쐬
    * @param win String EBhẼ[g(top)ȉ̃t[
    * @param name String m[h
    * @return Object|null HTMLvf
    */
    {
    var frame = Static.getWindow(win);
    var target = null;
    if(frame && name)
      {
      target = frame.document.createElement(name);
      }
    return target;
    };
  //------------------------------------------------------------------------------
  Static.setBgColor = function(obj, color)
   /**
    * wiFݒ肷
    * @param obj Object ݒΏۗvf
    * @param color String wiF
    */
    {
    if(((typeof obj) == "object") && ((typeof obj.style) == "object") && ((typeof color) == "string"))
      {
      obj.style.backgroundColor = color;
      }
    };
  //------------------------------------------------------------------------------
  Static.setFgColor = function(obj, color)
   /**
    * Fݒ肷
    * @param obj Object ݒΏۗvf
    * @param color String F
    */
    {
    if(((typeof obj) == "object") && ((typeof obj.style) == "object") && ((typeof color) == "string"))
      {
      obj.style.color = color;
      }
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.judgeState = function()
   /**
    * \ׂԂ𔻒肷
    */
    {
    };
  //------------------------------------------------------------------------------
  Proto.judge = function()
   /**
    * \𔻒肷
    */
    {
    this.judgeState();
    };
  //------------------------------------------------------------------------------
  Proto.flashState = function()
   /**
    * \ԂXV
    */
    {
    };
  //------------------------------------------------------------------------------
  Proto.flash = function()
   /**
    * \XV
    */
    {
    this.flashState();
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(key)
   /**
    * \Rg[NX
    * @param key String L[
    * @return jsd.container.DisplayControl CX^X
    * @through StringFormatException|ParameterFormatException|DoubleDefinitionException
    */
    {
    registInstance(key, this);
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  });

