/******************************************************************************/
/*                                                                            */
/*      Tv            HTMLԊǗNX                                    */
/*      \            EventState                                            */
/*      pbP[W  jsd.container                                         */
/*      ŏIXV      2006/05/27(Sat)                                       */
/*      o[W      1.00.00                                               */
/*      쌠\      Copyright (C) 2006 Mug, All rights reserved.          */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * ԊǗNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.container.EventStateNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  //:C ComplateName@js.cpt.Package.Creator String SCNX
  Creator.CompleteName = "jsd.container.EventState";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  // Ԓ萔
  //:S NULL null 
  Static.STATE_NULL = null;
  //:S IDLE Number 
  Static.STATE_IDLE = 0;
  //:S READY Number 
  Static.STATE_READY = 1;
  //:S RUNNING Number s
  Static.STATE_RUNNING = 2;
  //:S PAUSE Number f
  Static.STATE_PAUSE = -1;
  //:S END Number I
  Static.STATE_END = 4;
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * ԊǗNX
    * @return jsd.container.EventState CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v state Number|null 
    var state = Static.State_NULL;
    //:v length Number|null 
    var length = null;
    //:v count Number|null JEg
    var count = null;
    //:v result Boolean|null 
    var result = null;
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.getState = function()
     /**
      * Ԃ擾
      * @return Number|null (Static.STATE)
      */
      {
      return state;
      };
    //------------------------------------------------------------------------------
    this.getRange = function()
     /**
      * 擾
      * @return Number|null (1=100%)
      */
      {
      var range = null;
      if(((typeof length) == "number") && ((typeof count) == "number") && (length > 0))
        {
        range = count / length;
        }
      return range;
      };
    //------------------------------------------------------------------------------
    this.getLength = function()
     /**
      * 擾
      * @return Number|null 
      */
      {
      return length;
      };
    //------------------------------------------------------------------------------
    this.getCount = function()
     /**
      * JEg擾
      * @return Number|null JEg
      */
      {
      return count;
      };
    //------------------------------------------------------------------------------
    this.getResult = function()
     /**
      * ʂ擾
      * @return Boolean|null 
      */
      {
      return result;
      };
    //------------------------------------------------------------------------------
    this.init = function()
     /**
      * 
      * @return Boolean ǂ
      */
      {
      if(state != Static.STATE_NULL)
        {
        return false;
        }
      state  = Static.STATE_IDLE;
      length = null;
      count  = null;
      result = null;
      if((typeof this.oninit) == "function")
        {
        this.oninit();
        }
      return true;
      };
    //------------------------------------------------------------------------------
    this.ready = function(len)
     /**
      * 
      * @param len Number 
      * @return Boolean ǂ
      */
      {
      if(state != Static.STATE_IDLE)
        {
        return false;
        }
      if(((typeof len) != "number") || (len < 1))
        {
        return false;
        }
      state  = Static.STATE_READY;
      length = Math.floor(len);
      count  = 0;
      result = null;
      if((typeof this.onready) == "function")
        {
        this.onready();
        }
      return true;
      };
    //------------------------------------------------------------------------------
    this.step = function()
     /**
      * i߂
      * @return Boolean ǂ
      */
      {
      if((state != Static.STATE_READY) && (state != Static.STATE_RUNNING))
        {
        return false;
        }
      if(state == Static.STATE_READY)
        {
        state = Static.STATE_RUNNING;
        if((typeof this.onstart) == "function")
          {
          this.onstart();
          }
        }
      count++;
      if((typeof this.onstep) == "function")
        {
        this.onstep();
        }
      if(count >= length)
        {
        this.stop();
        }
      return true;
      };
    //------------------------------------------------------------------------------
    this.stop = function()
     /**
      * ~
      * @return Boolean ǂ
      */
      {
      if((state != Static.STATE_READY) && (state != Static.STATE_RUNNING) && (state != Static.STATE_PAUSE))
        {
        return false;
        }
      state = Static.STATE_END;
      result = (count >= length);
      if((typeof this.onstop) == "function")
        {
        this.onstop();
        }
      if(result && ((typeof this.onfinish) == "function"))
        {
        this.onfinish();
        }
      return true;
      };
    //------------------------------------------------------------------------------
    this.pause = function()
     /**
      * f
      * @return Boolean ǂ
      */
      {
      if(state != Static.STATE_RUNNING)
        {
        return false;
        }
      state = Static.STATE_PAUSE;
      if((typeof this.onpause) == "function")
        {
        this.onpause();
        }
      return true;
      };
    //------------------------------------------------------------------------------
    this.release = function()
     /**
      * ĊJ(ēxisł悤ɂ)
      * @return Boolean ǂ
      */
      {
      if(state != Static.STATE_PAUSE)
        {
        return false;
        }
      state = Static.STATE_RUNNING;
      if((typeof this.onrelease) == "function")
        {
        this.onrelease();
        }
      return true;
      };
    //------------------------------------------------------------------------------
    this.destroy = function()
     /**
      * j
      * @return Boolean ǂ
      */
      {
      state  = Static.STATE_NULL;
      length = null;
      count  = null;
      result = null;
      if((typeof this.ondestroy) == "function")
        {
        this.ondestroy();
        }
      return true;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  });

