/******************************************************************************/
/*                                                                            */
/*      Tv            JSDRpCpQƖNX                           */
/*      \            Reference                                             */
/*      pbP[W  jsd.ref                                               */
/*      ŏIXV      2006/05/31(Wed)                                       */
/*      o[W      2.00.00                                               */
/*      쌠\      Copyright (C) 2004-2006 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

Class.create(function(Super)
 /**
  * QƖNXNG[^[
  * @param Super [Function|null] X[p[NX
  * @return Function jsd.ref.ReferenceNX
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "jsd.ref.Reference";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  //:V Host Function jsd.ref.Host
  var Host = jsd.ref.Host;
  //:V Path Function jsd.ref.Path
  var Path = jsd.ref.Path;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEstaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //:C PROTOCOL_TOKEN String vgR؂蕶
  Class.PROTOCOL_TOKEN = ":";
  //:C SEARCH_TOKEN String ؂蕶
  Class.SEARCH_TOKEN = "?";
  //:C QUERY_TOKEN String NG[؂蕶
  Class.QUERY_TOKEN = "&";
  //:C VALUE_TOKEN String NG[l̋؂蕶
  Class.VALUE_TOKEN = "=";
  //:C HASH_TOKEN String nbV؂蕶
  Class.HASH_TOKEN = "#";
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.getSearch = function()
   /**
    * 擾
    * @return String|null (؂蕶͊܂܂Ȃ)
    */
    {
    var queries = this.getQueries();
    var search = (queries ? "" : null);
    if(queries)
      {
      for(var key in queries)
        {
        var val = queries[key];
        if(((typeof val) == "object") && (val instanceof Array))
          {
          for(var i = 0; i < val.length; i++)
            {
            if(search)
              {
              search += Class.QUERY_TOKEN;
              }
            search += key;
            if((typeof val[i]) == "string")
              {
              search += Class.VALUE_TOKEN + val[i];
              }
            }
          }
        else if((typeof val) == "string")
          {
          if(search)
            {
            search += Class.QUERY_TOKEN;
            }
          search += key + Class.VALUE_TOKEN + val;
          }
        else
          {
          if(search)
            {
            search += Class.QUERY_TOKEN;
            }
          search += key;
          }
        }
      }
    return search;
    };
  //------------------------------------------------------------------------------
  Proto.setSearch = function(search)
   /**
    * ݒ肷
    * @param search String|null 
    * @throws StringFormatException s
    */
    {
    if((search !== null) && ((typeof search) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, null, search, "search", "String|null", "FAIL");
      }
    if(search == null)
      {
      this.setQueries(null);
      }
    else
      {
      while((search.length > 0) && (search.charAt(0) == Class.SEARCH_TOKEN))
        {
        search = search.substring(Class.SEARCH_TOKEN.length, search.length);
        }
      var queries = {};
      if(search)
        {
        var q = search.split(Class.QUERY_TOKEN);
        for(var i = 0; i < q.length; i++)
          {
          if(q[i])
            {
            var key, val, idx = q[i].indexOf(Class.VALUE_TOKEN, 0);
            if(idx >= 0)
              {
              key = q[i].substring(0, idx);
              val = q[i].substring(idx + Class.VALUE_TOKEN, q[i].length);
              }
            else
              {
              key = q[i];
              val = null;
              }
            if(key)
              {
              if(queries.hasOwnProperty(key))
                {
                if((typeof queries[key]) != "object")
                  {
                  queries[key] = [queries[key]];
                  }
                queries[key][queries[key].length] = val;
                }
              else
                {
                queries[key] = val;
                }
              }
            }
          }
        }
      this.setQueries(queries);
      }
    };
  //------------------------------------------------------------------------------
  Proto.isAbsolute = function()
   /**
    * ΎQƂǂ擾
    * @return Boolean ΎQƂǂ
    */
    {
    var path = this.getPath();
    var isAbs = path ? path.isAbsolute() : (this.getProtocol() || this.getHost() || this.getDrive());
    return isAbs;
    };
  //------------------------------------------------------------------------------
  Proto.getURL = function()
   /**
    * URL\L̎QƃIuWFNg擾
    * @condition ̃IuWFNg͐ΎQƂłȂ΂ȂȂB
    * @return jsd.ref.Reference|null URL\L̎QƃIuWFNg
    */
    {
    var obj = null;
    if(this.isAbsolute())
      {
      var protocol = this.getProtocol();
      var host = this.getHost();
      var drive = this.getDrive();
      if(protocol || host)
        {
        obj = new Class(this.toString());
        }
      else if(drive)
        {
        var path = this.getPath();
        var token = (path && path.token) ? path.token : Path.FOLDER_TOKEN;
        obj = new Class(token + this.toString());
        obj.setProtocol("file");
        }
      else
        {
        obj = new Class(this.toString());
        obj.setProtocol("file");
        }
      obj.getPath().token = Path.DIRECTORY_TOKEN;
      }
    return obj;
    };
  //------------------------------------------------------------------------------
  Proto.toString = function()
   /**
    * \擾
    * @return String \
    */
    {
    var protocol = this.getProtocol();
    var host     = this.getHost();
    var drive    = this.getDrive();
    var path     = this.getPath();
    var search   = this.getSearch();
    var hash     = this.getHash();
    var ref = "";
    if(path && !path.isAbsolute())
      {
      ref += path;
      }
    else
      {
      var token = path ? path.token : null;
      if(!token || ((typeof token) != "string"))
        {
        token = Path.DIRECTORY_TOKEN;
        }
      if(protocol)
        {
        ref += protocol + Class.PROTOCOL_TOKEN;
        }
      if(protocol || host)
        {
        ref += token + token + (host ? host : "");
        }
      else if(drive)
        {
        ref += drive;
        }
      if(path)
        {
        ref += path;
        }
      if(protocol && ((typeof search) == "string"))
        {
        ref += Class.SEARCH_TOKEN + search;
        }
      if(protocol && ((typeof hash) == "string"))
        {
        ref += Class.HASH_TOKEN + hash;
        }
      }
    return ref;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(ref)
   /**
    * QƖNX
    * @param ref [String] Qƕ
    * @return jsd.ref.Reference CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v protocol String|null vgR
    var protocol = null;
    //:v host jsd.ref.Host|null zXg
    var host = null;
    //:v drive String|null hCu
    var drive = null;
    //:v path jsd.ref.Path|null pX
    var path = null;
    //:v queries Object|null NG[̃}bv
    var queries = null;
    //:v hash String|null nbV
    var hash = null;
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.getProtocol = function()
     /**
      * vgR擾
      * @return String|null vgR
      */
      {
      return protocol;
      };
    //------------------------------------------------------------------------------
    this.setProtocol = function(protocolName)
     /**
      * vgRݒ肷
      * @param protocolName String|null vgR
      * @throws StringFormatException s
      */
      {
      if((protocolName !== null) && ((typeof protocolName) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, protocolName, "protocolName", "String|null", "FAIL");
        }
      protocol = protocolName;
      };
    //------------------------------------------------------------------------------
    this.getHost = function()
     /**
      * zXg擾
      * @return jsd.ref.Host|null zXgIuWFNg
      */
      {
      return host;
      };
    //------------------------------------------------------------------------------
    this.setHost = function(hostObj)
     /**
      * zXgݒ肷
      * @param hostObj jsd.ref.Host|null zXgIuWFNg
      * @throws ParameterFormatException s
      */
      {
      if((hostObj !== null) && !(hostObj instanceof Host))
        {
        throw new Error("ParameterFormatException", Creator.CompleteName, null, hostObj, "hostObj", "jsd.ref.Host|null", "FAIL");
        }
      host = hostObj;
      };
    //------------------------------------------------------------------------------
    this.getDrive = function()
     /**
      * hCu擾
      * @return String|null hCu
      */
      {
      return drive;
      };
    //------------------------------------------------------------------------------
    this.setDrive = function(driveName)
     /**
      * hCuݒ肷
      * @param driveName String|null hCu
      * @throws StringFormatException s
      */
      {
      if((driveName !== null) && (!driveName || ((typeof driveName) != "string")))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, driveName, "driveName", "NotEmptyString|null", "FAIL");
        }
      drive = driveName;
      };
    //------------------------------------------------------------------------------
    this.getPath = function()
     /**
      * pX擾
      * @return jsd.ref.Path|null pXIuWFNg
      */
      {
      return path;
      };
    //------------------------------------------------------------------------------
    this.setPath = function(pathObj)
     /**
      * pXݒ肷
      * @param pathObj jsd.ref.Path|null pXIuWFNg
      * @throws ParameterFormatException s
      */
      {
      if((pathObj !== null) && !(pathObj instanceof Path))
        {
        throw new Error("ParameterFormatException", Creator.CompleteName, null, pathObj, "pathObj", "jsd.ref.Path|null", "FAIL");
        }
      path = pathObj;
      };
    //------------------------------------------------------------------------------
    this.getQueries = function()
     /**
      * NG[IuWFNg擾
      * @return Object|null NG[IuWFNg
      */
      {
      return queries;
      };
    //------------------------------------------------------------------------------
    this.setQueries = function(queryObj)
     /**
      * NG[IuWFNgݒ肷
      * @param queryObj Object|null NG[IuWFNg
      * @throws ParameterFormatException s
      */
      {
      if((queryObj !== null) && ((typeof queryObj) != "object"))
        {
        throw new Error("ParameterFormatException", Creator.CompleteName, nul, queryObj, "queryObj", "Object|null", "FAIL");
        }
      queries = queryObj;
      };
    //------------------------------------------------------------------------------
    this.getHash = function()
     /**
      * nbV擾
      * @return String|null nbV
      */
      {
      return hash;
      };
    //------------------------------------------------------------------------------
    this.setHash = function(hashName)
     /**
      * nbVݒ肷
      * @param hashName String|null nbV
      * @throws StringFormatException s
      */
      {
      if((hashName !== null) && ((typeof hashName) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, null, hashName, "hashName", "String|null", "FAIL");
        }
      hash = hashName;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    if(ref && ((typeof ref) == "string"))
      {
      var idx;
      var dIdx = ref.indexOf(Path.DIRECTORY_TOKEN, 0);
      var fIdx = ref.indexOf(Path.FOLDER_TOKEN, 0);
      var token;
      if(dIdx < 0)
        {
        dIdx = ref.length;
        }
      if(fIdx < 0)
        {
        fIdx = ref.length;
        }
      if(dIdx < fIdx)
        {
        token = Path.DIRECTORY_TOKEN;
        }
      else if(dIdx > fIdx)
        {
        token = Path.FOLDER_TOKEN;
        }
      else
        {
        token = null;
        }
      if(token)
        {
        idx = ref.indexOf(Class.PROTOCOL_TOKEN + token + token, 0);
        if(idx >= 0)
          {
          this.setProtocol(ref.substring(0, idx));
          ref = ref.substring(idx + Class.PROTOCOL_TOKEN.length, ref.length);
          }
        idx = ref.indexOf(token + token, 0);
        if(idx == 0)
          {
          ref = ref.substring(idx + (token + token).length, ref.length);
          idx = ref.indexOf(token, 0);
          if(idx < 0)
            {
            idx = ref.length;
            }
          if(idx > 0)
            {
            this.setHost(new Host(ref.substring(0, idx)));
            ref = ref.substring(idx, ref.length);
            }
          }
        else if((ref.length >= 2) && ((/^[A-Z]$/).test(ref.charAt(0)) && (ref.charAt(1) == ":") && ((ref.length == 2) || (ref.charAt(2) == token))))
          {
          idx = ref.indexOf(token, 0);
          if(idx < 0)
            {
            idx = ref.length;
            }
          if(idx > 0)
            {
            this.setDrive(ref.substring(0, idx));
            ref = ref.substring(idx, ref.length);
            }
          }
        }
      var qIdx = ref.indexOf(Class.SEARCH_TOKEN, 0);
      var hIdx = ref.indexOf(Class.HASH_TOKEN, 0);
      if((qIdx < 0) && (hIdx < 0))
        {
        // Do noting.
        }
      else if((qIdx < 0) && (hIdx >= 0))
        {
        this.setHash(ref.substring(hIdx + Class.HASH_TOKEN.length, ref.length));
        ref = ref.substring(0, hIdx);
        }
      else if((qIdx >= 0) && (hIdx < 0))
        {
        this.setSearch(ref.substring(qIdx + Class.SEARCH_TOKEN.length, ref.length));
        ref = ref.substring(0, qIdx);
        }
      else if(qIdx < hIdx)
        {
        this.setSearch(ref.substring(qIdx + Class.SEARCH_TOKEN.length, hIdx));
        this.setHash(ref.substring(hIdx + Class.HASH_TOKEN.length, ref.length));
        ref = ref.substring(0, qIdx);
        }
      else if(qIdx > hIdx)
        {
        this.setHash(ref.substring(hIdx + Class.HASH_TOKEN.length, qIdx));
        this.setSearch(ref.substring(qIdx + Class.SEARCH_TOKEN.length, ref.length));
        ref = ref.substring(0, hIdx);
        }
      else
        {
        ref = ref.substring(0, Math.min(qIdx, hIdx));
        }
      this.setPath(new Path(ref));
      }
    return this;
    }
  
  return Class;
  });
